import java.io.*;
import java.util.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;

class Analysis {
	private static Connection conn =  null;
	private static Properties dbProps = null;
	private static String confFile = "db.conf";

	private static void loadDriver() {
		//String driver = "oracle.jdbc.driver.OracleDriver";
		try{
			String driver = "org.gjt.mm.mysql.Driver";
			//driver = "com.mysql.jdbc.Driver";
			Class.forName(driver);
		}
		catch(Exception e){System.out.println("Error: Driver not found ");}
		finally{}
	}

	Analysis() throws Exception{
		loadDriver();
		try{
			loadProperties(confFile);
		}catch (Exception e){
			e.printStackTrace(System.out);
			System.out.println("Properties could not be loaded... Please restart the server or check for database connectivity.");
		}finally{
		}
	}

	public void destroy(){// throws Exception
		try{
			conn.close();
			System.out.println("Releasing database connection.");
		} catch (Exception e){
			e.printStackTrace(System.out);
			System.out.println("Destroying Login servlet. Could not close database connection..");
		}finally{
		}
		System.out.println("All Resources Released");
	}

	private void loadProperties(String propFileName)
		throws IOException {
		FileInputStream fis = new FileInputStream(propFileName);
		dbProps = new Properties();
		dbProps.load(fis);
		}


	public static Connection getConnection() {
		// Load the required drivers
		Analysis.loadDriver();
		try {
			int dbPort = Integer.parseInt(dbProps.getProperty("dbport"));
			String dbHost = dbProps.getProperty("dbhost");
			String dbUser = dbProps.getProperty("dbuser");
			String dbPassword = dbProps.getProperty("dbpassword");
			String dbName = dbProps.getProperty("dbname");
			String dbType = dbProps.getProperty("dbtype");

			String jdbcString = "jdbc:"+dbType+"://"+dbHost+"/"+dbName+"?user="+dbUser+"&password="+dbPassword;
			// Don't print the string as then passwd will be exposed
			//System.out.println(jdbcString);
			if(conn == null){
				conn = DriverManager.getConnection(jdbcString);
				System.out.println("Creating a new database connection");
			}else if(conn.isClosed()){
				System.out.println("Connection was lost, May be because of time out. Reconnect it.");
				conn=DriverManager.getConnection(jdbcString);
			}
		}catch (Exception e){//out.println("some weird 1exception has been caught");
		}finally{
		}
		return conn;
	}

	public void relConnection(){
		//Hmm... Do nothing...
	}

	public static ResultSet getTable(Connection conn, String query) throws Exception{
		PreparedStatement pstmt = conn.prepareStatement(query);
		System.out.println(query);
		ResultSet rs = pstmt.executeQuery();
		  //if(rs.next()) System.out.println("true......true");
                  //      else System.out.println("r=false");

//		System.out.println(rs.getString("value"));
		System.out.println("Query executed....");
      
                                                                                                                             
 
		return rs;
	}
	public static ResultSet exQuery(Connection conn, String query) throws Exception{
		PreparedStatement pstmt = conn.prepareStatement(query);
		System.out.println(query);
		ResultSet rs = pstmt.executeQuery();
		  //if(rs.next()) System.out.println("true......true");
                  //      else System.out.println("r=false");

//		System.out.println(rs.getString("value"));
		System.out.println("Query executed....");
      
                                                                                                                             
 
		return rs;
	}

// select uid, marks from marks where sid = rs.getInt("sid") and marks cond value
	// select name from user where uid = rs.getInt("uid")
	public static ResultSet query(String field, String condition, String value) throws Exception{
//		ResultSet rs3;
	
		String query2 = "select name,marks,user.uid from user,marks where marks.sid = " + field + " and marks.marks " + condSymbol(condition) + " "+ value + " and user.uid=marks.uid";
		ResultSet rs2 = getTable(getConnection(), query2);
		//while(rs2.next())
		System.out.println(query2);
		//String query3 = "select name from user where uid = " + rs2.getInt("uid");
		//rs3 = getTable(getConnection(), query3);
		//System.out.println(query3);
		//}
//		}catch(Exception E){}
		return rs2;
	}


	public static String condSymbol(String condition) {
                int cond = Integer.parseInt(condition);
                switch(cond){
                case 1 : return ((String)" < ");
                case 2 : return ((String)" <=");
                case 3 : return ((String)" > ");
                case 4 : return ((String)" >= ");
                case 5 : return ((String)" = ");
                case 6 : return ((String)" != ");
                }
		return ("=");
        }


	public static String condTranslate(String condition) {
		int cond = Integer.parseInt(condition);
		switch(cond){
		case 1 : return ((String)"Less Than ");
		case 2 : return ((String)"Less Than or Equal To");
		case 3 : return ((String)"Greater Than ");
		case 4 : return ((String)"Greater Than or Equal To");
		case 5 : return ((String)"Equal To");
		case 6 : return ((String)"Not Equal To");
		}
		return ("Equal To");
	}






	public static boolean loginData(Connection conn,String ln,String ps){
		String query = "Select password from user where login='"+ln+"' and password='"+ps+"'";
		//String query="Select * from user";
		System.out.println(query);
		boolean r=true;
			
		//System.out.println(query);
		try{
			//System.out.println("Here1");
			PreparedStatement pstmt = conn.prepareStatement(query);
			//System.out.println("Here");
			ResultSet rs = pstmt.executeQuery();
			//rs.next();
			//System.out.println("Here2");
		
			//System.out.println(rs.getString("password"));
			if(rs.next()) r=true;
			else r=false;

		}catch (Exception e){//out.println("some weird 1exception has been caught");
		}finally{
		}		
	
		return r;
	}

	public static boolean hasUserSubmitted(String login){
		boolean r=false;
		try{
		String query = "select submitted from user where login = \'" + login + "\';";
		PreparedStatement pstmt1 = conn.prepareStatement(query);
                ResultSet rs1 = pstmt1.executeQuery();
		System.out.println(query);	
		rs1.next();
		if(rs1.getInt("submitted") == 1)
                        r = false;
                else
                        r = true;
		System.out.println("Yes it is ..................");
		}catch(Exception e){}

		return r;

	}

	public static void preInsertMarks(String login){
		try{
		String query1 = "select uid from user where login=\'" + login + "\';";
		 PreparedStatement pstmt1 = conn.prepareStatement(query1);
                ResultSet rs1 = pstmt1.executeQuery();
		System.out.println("Hello;;;;;;;;;;;;");
		rs1.next();
		String query4 = "delete from marks where uid = " + rs1.getInt("uid") ;
		System.out.println(query4);

                PreparedStatement pstmt4 = conn.prepareStatement(query4);
                if(pstmt4.execute())
                        System.out.println("The query could not be exceuted......");

		//System.out.println(query5);
		String query5 = "update user set submitted = 1 where uid = " + rs1.getInt("uid") ;
                System.out.println(query5);
                                                                                                                             
                PreparedStatement pstmt5 = conn.prepareStatement(query5);
                if(pstmt5.execute())
                        System.out.println("The query could not be exceuted......");
                                                                                                                             

		}catch(Exception E){}
	}

	public static void insertMarks(String login, String subject,int marks){
		int uid , sid;
		String query1 = "select uid from user where login=\'" + login + "\';";
		String query2 = "select sid from subject where value=\'" + subject + "\';";

		try{
		PreparedStatement pstmt1 = conn.prepareStatement(query1);
                ResultSet rs1 = pstmt1.executeQuery();
		if(rs1.next()) System.out.println("true......true");
                        else System.out.println("r=false");

		System.out.println(query1);
		PreparedStatement pstmt2 = conn.prepareStatement(query2);
                ResultSet rs2 = pstmt2.executeQuery();
		if(rs2.next()) System.out.println("true......true");
                        else System.out.println("r=false");
		System.out.println(query2 + rs2.getInt("sid"));
		String query3 = "insert into marks (uid, sid, marks) values ( " + rs1.getInt("uid") + ", " + rs2.getInt("sid") + ", " + marks + ");";

		System.out.println(query3);
	//	String query4 = "delete from marks where uid = " + rs1.getInt("uid") ;
	//	exQuery(conn, query4);
		PreparedStatement pstmt3 = conn.prepareStatement(query3);
                if(pstmt3.execute())
			System.out.println("The query could not be exceuted......");
		} catch(Exception E){}
	}



}
